package stackjava.com.tutorial;

import java.util.concurrent.*;

public class Demo3 {
	public static void main(String[] args) throws InterruptedException, ExecutionException {
		ExecutorService executor = Executors.newFixedThreadPool(10);

		CompletableFuture<Integer> future1 = CompletableFuture.supplyAsync(() -> Calculator.add(1,2), executor);
		CompletableFuture<Integer> future2 = CompletableFuture.supplyAsync(() -> Calculator.add(1,3), executor);
		CompletableFuture<Integer> future3 = CompletableFuture.supplyAsync(() -> Calculator.add(2,3), executor);
		
		System.out.println("Done");
		executor.shutdown();
		
		future1.thenRun(()->{
			System.out.println("future1 completed!");
		});
		future2.thenAccept(result ->{
			System.out.println("future2 completed, result = " + result);
		});
		future3.handle((data, error) ->{
			if (error != null){
				System.out.println("future3 error, error: " + error);
				return null;
			} else {
				System.out.println("future3 completed, result = " + data);
				return data;
			}
			
		});
		
		
	}
}
