package stackjava.com.tutorial;

import java.util.concurrent.*;

public class Demo4 {
	public static void main(String[] args) throws InterruptedException, ExecutionException {
		ExecutorService executor = Executors.newFixedThreadPool(10);

		CompletableFuture<Integer> future = CompletableFuture.supplyAsync(() -> Calculator.add(1,2), executor);
		
		future.thenApplyAsync(data->{
			System.out.println("CompletableFuture 1 done");
			return Calculator.add(1,3); // CompletableFuture 2
		}).thenApplyAsync(data->{
			System.out.println("CompletableFuture 2 done");
			return Calculator.add(2,3); // CompletableFuture 3
		}).thenAcceptAsync(data ->{
			System.out.println("CompletableFuture 3 done");
		}).thenRun(()->{
			System.out.println("Finished!");
		});
		
		executor.shutdown();
	}
}
